
# instal ---->>>  pip install python-can
import can
import time
import RPi.GPIO as GPIO
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
print ("SG Electronic Systems srls")
print ("Relay V1.0.0 Relays CAN controlled")
#Relay 1
GPIO.setup(6,GPIO.OUT)
GPIO.output(6,GPIO.HIGH)
#Relay 2
GPIO.setup(12,GPIO.OUT)
GPIO.output(12,GPIO.HIGH)
#Relay 3
GPIO.setup(13,GPIO.OUT)
GPIO.output(13,GPIO.HIGH)
#Relay 4
GPIO.setup(19,GPIO.OUT)
GPIO.output(19,GPIO.HIGH)
#Relay 5
GPIO.setup(16,GPIO.OUT)
GPIO.output(16,GPIO.HIGH)
#Relay 6
GPIO.setup(26,GPIO.OUT)
GPIO.output(26,GPIO.HIGH)
#Relay 7
GPIO.setup(20,GPIO.OUT)
GPIO.output(20,GPIO.HIGH)
#Relay 8
GPIO.setup(21,GPIO.OUT)
GPIO.output(21,GPIO.HIGH)
print ("All relays off")
#Led 1 CAN BUS Board
GPIO.setup(27,GPIO.OUT)
GPIO.output(27,GPIO.LOW)
#Led 2 CAN BUS Board
GPIO.setup(4,GPIO.OUT)
GPIO.output(4,GPIO.LOW)
can_interface = 'can0'
bus = can.interface.Bus(can_interface, bustype='socketcan',bitrate=500000)

def led1_blink():
	GPIO.output(27,GPIO.HIGH)
	time.sleep(1/100)
	GPIO.output(27,GPIO.LOW)
	
def led2_blink():
   	GPIO.output(4,GPIO.HIGH)
	time.sleep(1/100)
	GPIO.output(4,GPIO.LOW)

def rel_on(rel_num):
	if (rel_num == 1):
		GPIO.output(6,GPIO.LOW)
	elif (rel_num == 2):
		GPIO.output(12,GPIO.LOW)
	elif (rel_num == 3):
		GPIO.output(13,GPIO.LOW)
	elif (rel_num == 4):
		GPIO.output(19,GPIO.LOW)
	elif (rel_num == 5):
		GPIO.output(16,GPIO.LOW)
	elif (rel_num == 6):
		GPIO.output(26,GPIO.LOW)
	elif (rel_num == 7):
		GPIO.output(20,GPIO.LOW)
	elif (rel_num == 8):
		GPIO.output(21,GPIO.LOW)	

def rel_off(rel_num):
	if (rel_num == 1):
		GPIO.output(6,GPIO.HIGH)
	elif (rel_num == 2):
		GPIO.output(12,GPIO.HIGH)
	elif (rel_num == 3):
		GPIO.output(13,GPIO.HIGH)
	elif (rel_num == 4):
		GPIO.output(19,GPIO.HIGH)
	elif (rel_num == 5):
		GPIO.output(16,GPIO.HIGH)
	elif (rel_num == 6):
		GPIO.output(26,GPIO.HIGH)
	elif (rel_num == 7):
		GPIO.output(20,GPIO.HIGH)
	elif (rel_num == 8):
		GPIO.output(21,GPIO.HIGH)			

while True:
	message = bus.recv()
	print("Message Received", message)
	if (message.arbitration_id == 0x1B2):
		led1_blink()
		if (message.data[0] >= 1 and message.data[0]<=8):
			led2_blink()
			print("Relay ",  message.data[0])
			if (message.data[1] == 1):
				print("On ")
				rel_on(message.data[0])
			elif (message.data[1] == 0):
				print("Off ")
				rel_off(message.data[0])
